# coding: utf-8

"""
    Sonatype Lifecycle Public REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.184.0-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from sonatype_iq_api_client.models.api_component_project_metadata_dto import ApiComponentProjectMetadataDTO
from sonatype_iq_api_client.models.api_component_project_scm_dto import ApiComponentProjectScmDTO
from typing import Optional, Set
from typing_extensions import Self

class ApiComponentProjectDataDTO(BaseModel):
    """
    ApiComponentProjectDataDTO
    """ # noqa: E501
    first_release_date: Optional[datetime] = Field(default=None, alias="firstReleaseDate")
    last_release_date: Optional[datetime] = Field(default=None, alias="lastReleaseDate")
    project_metadata: Optional[ApiComponentProjectMetadataDTO] = Field(default=None, alias="projectMetadata")
    source_control_management: Optional[ApiComponentProjectScmDTO] = Field(default=None, alias="sourceControlManagement")
    __properties: ClassVar[List[str]] = ["firstReleaseDate", "lastReleaseDate", "projectMetadata", "sourceControlManagement"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApiComponentProjectDataDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of project_metadata
        if self.project_metadata:
            _dict['projectMetadata'] = self.project_metadata.to_dict()
        # override the default output from pydantic by calling `to_dict()` of source_control_management
        if self.source_control_management:
            _dict['sourceControlManagement'] = self.source_control_management.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApiComponentProjectDataDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "firstReleaseDate": obj.get("firstReleaseDate"),
            "lastReleaseDate": obj.get("lastReleaseDate"),
            "projectMetadata": ApiComponentProjectMetadataDTO.from_dict(obj["projectMetadata"]) if obj.get("projectMetadata") is not None else None,
            "sourceControlManagement": ApiComponentProjectScmDTO.from_dict(obj["sourceControlManagement"]) if obj.get("sourceControlManagement") is not None else None
        })
        return _obj


