# coding: utf-8

"""
    Sonatype Lifecycle Public REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.184.0-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sonatype_iq_api_client.models.api_component_identifier_dtov2 import ApiComponentIdentifierDTOV2
from sonatype_iq_api_client.models.api_license_legal_data_dto import ApiLicenseLegalDataDTO
from sonatype_iq_api_client.models.api_license_legal_stage_scan_dto import ApiLicenseLegalStageScanDTO
from typing import Optional, Set
from typing_extensions import Self

class ApiLicenseLegalComponentDTO(BaseModel):
    """
    ApiLicenseLegalComponentDTO
    """ # noqa: E501
    component_identifier: Optional[ApiComponentIdentifierDTOV2] = Field(default=None, alias="componentIdentifier")
    display_name: Optional[StrictStr] = Field(default=None, alias="displayName")
    hash: Optional[StrictStr] = None
    license_legal_data: Optional[ApiLicenseLegalDataDTO] = Field(default=None, alias="licenseLegalData")
    package_url: Optional[StrictStr] = Field(default=None, alias="packageUrl")
    stage_scans: Optional[List[ApiLicenseLegalStageScanDTO]] = Field(default=None, alias="stageScans")
    __properties: ClassVar[List[str]] = ["componentIdentifier", "displayName", "hash", "licenseLegalData", "packageUrl", "stageScans"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApiLicenseLegalComponentDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of component_identifier
        if self.component_identifier:
            _dict['componentIdentifier'] = self.component_identifier.to_dict()
        # override the default output from pydantic by calling `to_dict()` of license_legal_data
        if self.license_legal_data:
            _dict['licenseLegalData'] = self.license_legal_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in stage_scans (list)
        _items = []
        if self.stage_scans:
            for _item_stage_scans in self.stage_scans:
                if _item_stage_scans:
                    _items.append(_item_stage_scans.to_dict())
            _dict['stageScans'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApiLicenseLegalComponentDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "componentIdentifier": ApiComponentIdentifierDTOV2.from_dict(obj["componentIdentifier"]) if obj.get("componentIdentifier") is not None else None,
            "displayName": obj.get("displayName"),
            "hash": obj.get("hash"),
            "licenseLegalData": ApiLicenseLegalDataDTO.from_dict(obj["licenseLegalData"]) if obj.get("licenseLegalData") is not None else None,
            "packageUrl": obj.get("packageUrl"),
            "stageScans": [ApiLicenseLegalStageScanDTO.from_dict(_item) for _item in obj["stageScans"]] if obj.get("stageScans") is not None else None
        })
        return _obj


