# coding: utf-8

"""
    Sonatype Lifecycle Public REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.184.0-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from sonatype_iq_api_client.models.api_policy_violation_dtov2 import ApiPolicyViolationDTOV2
from sonatype_iq_api_client.models.api_repository_component_evaluation_request import ApiRepositoryComponentEvaluationRequest
from typing import Optional, Set
from typing_extensions import Self

class ApiRepositoryComponentEvaluationResult(BaseModel):
    """
    ApiRepositoryComponentEvaluationResult
    """ # noqa: E501
    catalog_date: Optional[datetime] = Field(default=None, alias="catalogDate")
    component: Optional[ApiRepositoryComponentEvaluationRequest] = None
    policy_violations: Optional[List[ApiPolicyViolationDTOV2]] = Field(default=None, alias="policyViolations")
    quarantine_date: Optional[datetime] = Field(default=None, alias="quarantineDate")
    quarantined: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["catalogDate", "component", "policyViolations", "quarantineDate", "quarantined"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApiRepositoryComponentEvaluationResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of component
        if self.component:
            _dict['component'] = self.component.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in policy_violations (list)
        _items = []
        if self.policy_violations:
            for _item_policy_violations in self.policy_violations:
                if _item_policy_violations:
                    _items.append(_item_policy_violations.to_dict())
            _dict['policyViolations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApiRepositoryComponentEvaluationResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "catalogDate": obj.get("catalogDate"),
            "component": ApiRepositoryComponentEvaluationRequest.from_dict(obj["component"]) if obj.get("component") is not None else None,
            "policyViolations": [ApiPolicyViolationDTOV2.from_dict(_item) for _item in obj["policyViolations"]] if obj.get("policyViolations") is not None else None,
            "quarantineDate": obj.get("quarantineDate"),
            "quarantined": obj.get("quarantined")
        })
        return _obj


