# coding: utf-8

"""
    Sonatype Lifecycle Public REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.184.0-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from sonatype_iq_api_client.models.api_component_change_action_dto import ApiComponentChangeActionDTO
from typing import Optional, Set
from typing_extensions import Self

class ApiVersionChangeOptionDTO(BaseModel):
    """
    ApiVersionChangeOptionDTO
    """ # noqa: E501
    data: Optional[ApiComponentChangeActionDTO] = None
    direct_dependency: Optional[StrictBool] = Field(default=None, alias="directDependency")
    direct_dependency_data: Optional[List[ApiComponentChangeActionDTO]] = Field(default=None, alias="directDependencyData")
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["data", "directDependency", "directDependencyData", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['next-no-violations', 'next-non-failing', 'next-no-violations-with-dependencies', 'next-non-failing-with-dependencies', 'recommended-non-breaking', 'recommended-non-breaking-with-dependencies']):
            raise ValueError("must be one of enum values ('next-no-violations', 'next-non-failing', 'next-no-violations-with-dependencies', 'next-non-failing-with-dependencies', 'recommended-non-breaking', 'recommended-non-breaking-with-dependencies')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApiVersionChangeOptionDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data
        if self.data:
            _dict['data'] = self.data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in direct_dependency_data (list)
        _items = []
        if self.direct_dependency_data:
            for _item_direct_dependency_data in self.direct_dependency_data:
                if _item_direct_dependency_data:
                    _items.append(_item_direct_dependency_data.to_dict())
            _dict['directDependencyData'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApiVersionChangeOptionDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "data": ApiComponentChangeActionDTO.from_dict(obj["data"]) if obj.get("data") is not None else None,
            "directDependency": obj.get("directDependency"),
            "directDependencyData": [ApiComponentChangeActionDTO.from_dict(_item) for _item in obj["directDependencyData"]] if obj.get("directDependencyData") is not None else None,
            "type": obj.get("type")
        })
        return _obj


